// audio.c

int audio_frame(Ampler_state *state) {
	int queued = SDL_GetQueuedAudioSize(state -> playdev);
	queued /= sizeof s16; // queued is in bytes

	if queued > FRAME_SAMPLES * CHANNELS * 2 do return 0;
	// else puts("queued audio.");

	// TODO: ITERATE SOUNDS AND MIX IN SEP CHANNELS
	// TODO: THEN, CONVERT TO INTERLEAVED AND OUTPUT

	static s16 frame[SAMPLE_RATE * CHANNELS * 7] = { 0 };
	const int vol = 64;
	for int i = 0; i < arraylen(frame) / CHANNELS; i += 1 do
		for int t = 0; t < CHANNELS; t += 1 do
			frame[i * CHANNELS + t] = ((s16) (state -> tracks[t][i])) * vol;

	if SDL_QueueAudio(state -> playdev, frame, sizeof frame) do
		puts(SDL_GetError());

	return 1; // audio was qued
}

void load_track(Ampler_state *state) {
	SDL_AudioSpec spec;
	s16 *buffer = NULL;
	u32 bytes = 0;

	SDL_LoadWAV("sample.wav", &spec, &buffer, &bytes);

	if spec.format != AUDIO_S16 do {
		puts("error: sample.wav is not s16");
		return;
	}

	const int chans = spec.channels;
	const int len = (bytes / sizeof s16) / chans;

	// TODO: VALIDATE LENGTH + TRACKS

	printf("loading sample.wav %f seconds.\n",
		((f32) len) / ((f32) SAMPLE_RATE));

	for int i = 0; i < len; i += 1 do
		for int t = 0; t < chans; t += 1 do
			state -> tracks[t][i] = (s8) (buffer[i * chans + t] >> 8);

	SDL_FreeWAV((void *) buffer);
}

void load_track_f32() { // idk if we're ever gonna be loading floats
	/*
	f32 max = 0.0f;
	for int i = 0; i < len; i++ do
		if buffer[i] > max do
			max = buffer[i];
		else if buffer[i] < -max do
			max = -buffer[i];
	printf("%f max\n", max);
	for int i = 0; i < len; i += 2 do {
		buffer[i] /= max;
		buffer[i + 1] /= max;
		state -> track_l[i] = ((s8)(buffer[i] * 127.0f));
		state -> track_r[i] = ((s8)(buffer[i + 1] * 127.0f));
	}
	*/
}

